<?php

include '../../core.php';

checkAuth("pkiOper");

cabecera (5);

$command = $_POST['request_command'];
$errorCode = "a0";

switch ($command) {

   default:

      echo "<h1>Selecci&oacute;n del fichero de importaci&oacute;n de certificados</h1>\n";

      echo "
      <form method='post' action='data_import.php' enctype='multipart/form-data' name='request_import_selfile'>
      <input type='hidden' name='request_command' value='request_import' />

      <div id='tbox'>
        <h3 class='head_a2b1'>Importar Datos</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>
            <div id='tname'>Fichero XML</div>
            <div id='tvalue'><input type='file' name='ca2raFile' size='35>'</div>
          </div>
          <div id='trow'>
            <div id='tvalue'><input class='button' type='submit' value='Importar' /></div>
          </div>
        </div>
      </div>

      </form>
      ";

      break;

   case "request_import":

      $csrFileName = $_FILES['ca2raFile']['name'];

      echo "<h1 class='title'>Importaci&oacute;n de Certificados</h1>\n";

      // Pasamos el archivo XML a una matriz
      $ca2raArray = parseXML($_FILES['ca2raFile']['tmp_name']);
      if ( !$ca2raArray )
	 $errorCode = "a2b2c5d2e1";
      else {
         // Obtenemos el tipo de XML para comprobar si es valido
         $xmlType = $ca2raArray[0]['xmlType'];      
      
         if ( $xmlType != '"crt"' ) 
	    $errorCode = "a2b2c5d2e12";
         else {	      
            // Vemos cuantos certificados hay en el fichero
            $requestsNum = count($ca2raArray);
            // Para cada certificado tendremos que generar un array y volcarlo al 
	    // ldap. Empieza desde la posicion 1 de la matriz porque en la 0 
	    // contiene informacion del fichero en lugar de una solicitud
            for($i=1; $i < $requestsNum; $i++) {
               $errorCode = "a0";
	    
               // Valores comunes 
               $copaId = $ca2raArray[$i]['copa_id'];
               $dn = $ldapVar['rdnAttr'] . "=$copaId," . $ldapVar['base'];
               $id = $ca2raArray[$i]['id'];
	       $status = $ca2raArray[$i]['status'];
               $date = $ca2raArray[$i]['date'];

               // Creamos un array con la informacion a anyadir al ldap	    
               $info['pkirisStatus'] = $status;
               $info['pkirisDate'] = $date;
	    
	       // Tenemos que ver si se trata de un certificado emitido,
               // revocado o una solicitud rechazada por la CA
               $request_type = $ca2raArray[$i]['requesttype'];
					  	    
               if ($request_type == "crt") {
                  // Para poder insertar el certificado en el ldap, tenemos que 
	          // asegurarnos de que existe una solicitud con ese numero copa
	          // y con estado "ra2ca"
   	          $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copaId)(pkirisStatus=ra2ca))";
                  $justthese = array ("count", "pkiriscerttype");
                  $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
                  if ( !$result )
                     $errorCode = "a2b2c5d1e1";
                  else if ($result['count'] == 0) 
                     $errorCode = "a2b2c5d2e2";               
                  // En este caso, preparamos los datos a importar al ldap
                  else {
		     // Obtenemos el certificado del XML en formato '.pem'. 
		     // Primero tenemos que pasarlo a un fichero 
		     $txtFile = $dirVar['crt'] . $copaId.".txt";
                     // Verificamos si existe el fichero y si no lo creamos y
                     // volcamos la info del certificado en el
                     if ( !file_exists($txtFile) ) {
                        $txt = fopen($txtFile, "w");
			if ( !$txt )
			   $errorCode = "a2b2c5d2e5";
			else {
		           $r = fputs($txt, $ca2raArray[$i]['data']);
			   if ( !$r )
			      $errorCode = "a2b2c5d2e6";	  
                        }		        
                        $r = fclose($txt);      
			if ( !$r )
			   $errorCode = "a2b2c5d2e8";
		     }

                     // Ahora ya lo podemos pasar de 'txt' a 'pem'		  
		     $pemFile = $dirVar['crt'] . $copaId.".pem";
		     $opensslCommand = $bin['openssl'] . " x509 < $txtFile  > $pemFile";
		  
		     $execReturn = system($opensslCommand, $retVal);
                     if ( $execReturn != "" )
                        $errorCode = "a2b2c5d2e3";
                     else {
		        // Pasamos de formato '.pem' a '.der' para poder insertarlo
		        // en el ldap. El fichero tendra una extension u otra 
		        // dependiendo del tipo de certificado (usuario o servidor)
		        $crtType = $result[0]["pkiriscerttype"][0];

		        if ( $crtType == "usr" )
 		           $derFile = $dirVar['crt'] . $copaId .".cer"; 
		        else
		           $derFile = $dirVar['crt'] . $copaId .".cer";
		     
                        $opensslCommand2 = $bin['openssl'] . " x509 -in $pemFile -inform PEM -out $derFile -outform DER";
  		        $execReturn2 = system($opensslCommand2, $retVal2);
  			if ( $execReturn2 != "" )
			   $errorCode = "a2b2c5d2e4";
		        else {
		           $derFd = fopen ($derFile, "r");
		           if ( !$derFd ) 
                              $errorCode = "a2b2c5d2e5";
		           else {
		              // Pasamos el certificado a una cadena
	                      $ldapCertString = "";
			      $buf = true;
		              while ( !feof($derFd) && $buf ) {
		                 $buf = fgets($derFd, 4096);
			 	 if ( !$buf )
				    $errorCode = "a2b2c5d2e7";
				 else
		                    $ldapCertString = $ldapCertString . $buf;
		              }	
                              $r = fclose ($derFd);
			      if ( !$r )
			 	 $errorCode = "a2b2c5d2e8";

		 	      if ( $buf ) {
                                 $info['userCertificate;binary'] = $ldapCertString;	       
                                 $info['pkirisCertificateExpirationDate'] = $ca2raArray[$i]['expiration_date'];

		                 list($raCopa, $k) = split("b", $copaId);
		                 $filter2 = "(&(objectClass=pkirisAuthority)(pkirisCopaID=$raCopa))";
                    	         $justthese2 = array("pkirisRaUrl");
		                 $result2 = ldap_get_info($ldapVar['base'], $filter2, $justthese2);
       		                 if ( !$result2 ) 
				    $errorCode = "a2b2c5d1e1";
				 else if ( $result['count'] == 0 )
                                    $errorCode = "a2b2c5d2e9";
                                 else {
                                    $lastStatus = getStatus($copaId);
                                    if ( !$lastStatus )
                                       $errorCode = "a2b2c5d2e10";
                                    // Nos aseguramos de que no se haya tratado
                                    // la CSR anteriormente
                                    else if ($lastStatus == $status)
                                       $errorCode = "a2b2c5d2e11";
                                    else { 			 
   		                       $crtRaUrl = $result2 [0]["pkirisraurl"][0];
		                       $downloadLink = $pkiris['homeURL'] . $crtRaUrl . "/crt_get.php";
	    	                       $mailSubject = "Certificado Emitido";
		                       $mailBody = "El certificado cuyo identificador es $id y n&uacute;mero copa $copaId ha sido emitido. Puede descargarlo de: $downloadLink .";
                                    }
		                 }
	                      }
                           }
                        }
                     }
                  }
               }
               else if ( $request_type == "rvk" ) { 
       	          // Si no hay ningun certificado firmado con ese numero copa no 
	          // podremos llevar a cabo la revocacion
                  $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copaId)(pkirisStatus=ra2ca))";
                  $justthese = array ("count");
                  $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
	          if ( !$result )
		     $errorCode = "a2b2c5d1e1";
		  else if ($result['count'] == 0)
		     $errorCode = "a2b2c5d2e2";
                  
                  // El caso de que si exista el certificado, guardamos el motivo
                  // de revocacion en la misma entrada
                  else {               
                     $lastStatus = getStatus($copaId);
                     if ( !$lastStatus )
                        $errorCode = "a2b2c5d2e10";                     
                     // Nos aseguramos de que no se haya tratado la CRR anteriormente 
                     else if ($lastStatus == $status)
                        $errorCode = "a2b2c5d2e11";
		     else {
		        $mailSubject = "Certificado Revocado";
                        $mailBody = "El certificado cuyo identificador es $id ha sido revocado.";
                     }		  
                  }
               }
	    
	       if ( $request_type == "rfd" ) {
  	          // Si no hay ninguna solicitud de certificado o revocacion 
	          // pendiente con ese numero copa no podremos rechazarla
                  $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copaId)(pkirisStatus=ra2ca))";
                  $justthese = array ("count");
                  $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
		  if ( !$result )
                     $errorCode = "a2b2c5d1e1";
                  else if ( $result['count'] == 0) 
		     $errorCode = "a2b2c5d2e2";
	          else {
                     $lastStatus = getStatus($copaId);
                     if ( !$lastStatus )
                        $errorCode = "a2b2c5d2e10";
                     // Nos aseguramos de que no se haya tratado la RFD 
		     // anteriormente
                     else if ($lastStatus == $status) 
			$errorCode = "a2b2c5d2e11";
	             else {
	                $mailSubject = "Solicitud Rechazada";
		        $mailBody = "La solicitud cuyo identificador es $id ha sido rechazada.";
                     }
	          }
	       }
               // Si no ha habido ningun error, escribimos los datos en el ldap
	       if ( $errorCode == "a0" ) {
     		    
  	          // Escribimos los datos en el ldap
                  $r = ldap_mod_info($dn,$info);
	          if ( !$r ) 
                     $errorCode = "a2b2c5d1e2";
	    
	          else {
		     // Escribimos las trazas
		     $urn['pkirisTrace'] = $ca2raArray[$i]['traces'];
		     $r = ldap_mod_add_info($dn,$urn);
                     if ( !$r ) 
    	                $errorCode = "a2b2c5d1e3";
	             else {
                        // Si todo va bien, le enviamos un correo al responsable del 
		        // certificado para informarle de la firma o revocacion del
		        // mismo
		        $mail = getMail($copaId);
		        if ( !$mail )
                           $errorCode = "a2b2c5d2e13";
                        else {
		           $envioMail = mail($mail, $mailSubject, $mailBody);
			   // Registramos la accion en el fichero de log
                           $pkiLog['status'] = "data_import";
                           $pkiLog['eee'] = $copaId;
                           $pkiLog['user'] = "PKIAdmin";
                           $pkiLog['error'] = $errorCode;
                           writeLog ($pkiLog);
                        }
		     }
	          }
	       }
            } //for
            if ( $errorCode == "a0" )
               echo "<p>La importaci&oacute;n se ha realizado con &eacute;xito.</p>";
         }
      }
      
   break; 
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error Importando las Solicitudes </h2>
         <p> Ha fallado al menos una solicitud y no se ha importado ninguna.</p>\n";

   $pkiLog['status'] = "data_import";
   $pkiLog['eee'] = $copaId;
   $pkiLog['user'] = "PKIAdmin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>
